/* ertrag.cc			letzte Aenderung: 23.6.2015 */
#define VERSION "Version 0.0"
/*
Uebersetzen auf Unix (Linux):
> make  ;siehe makefile

History:
20.6.2015       Erstellung (RP)
                .

*/

//#define NAEHERUNGSFORMEL  //auskommentieren fuer genauere Sonnenposition

#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <vektor3dklasse.cc>

/************************* Vordeklarationen ***************************/
int tgberechnung(int tag,int monat);
void sonnenaufgang_anzeigen(int jahr,int monat,int tag);
void sonnenuntergang_anzeigen(int jahr,int monat,int tag);

/************************* Globale Variablen **************************/
static int workbenchflag=0;

/**************** Routinen zur Parameterauswertung ********************/
#define MAXARG 2
static char argflag[128];
void setargflags(const char *s)
{
 int c;
 while(c= *s++)
  {if(c>='a' && c<='z')  c -= 'a'-'A';
   argflag[c&127]=1;
  }
}

/*************************** Kleinkram ********************************/
/*
bool istja(const char *s)
{
 int c= *s;
 return (c=='j' || c=='J' || c=='y' || c=='Y');
}
*/

bool getline(FILE *fp,char *s,int lim)
{		/* liest eine Textzeile oder maximal lim Zeichen */
		/* und ersetzt den Zeilentrenner durch 0         */
 int c=0;
 while(--lim && (c=getc(fp))!=EOF && c!='\n')
	*s++ = c;
 *s='\0';
 return (c!=EOF);	/* TRUE wenn erfolgreich, FALSE wenn Fileende */
}

void eingabe(const char *text,double *p1) //Nach einer Fliesszahl fragen und eingeben
{
 printf("%s",text);
 scanf("%lf",p1);
}

void eingabe2(const char *text,int *p1,int *p2) //Nach 2 Integerzahlen fragen und eingeben
{
 printf("%s",text);
 scanf("%d%*c%d",p1,p2);
}

void feinlesen(FILE *fp,const char *cstr,double *p1,double *p2=NULL)
{
 char zeile[160],*s=NULL;
 for(;;)
  {
   zeile[0]=0;
   if(!getline(fp,zeile,160)) {fprintf(stderr,"Zu wenige Daten in Eingabedatei.\n"); return;}
   //printf("Testpunkt1 in feinlesen(); cstr='%s' zeile='%s'\n",cstr,zeile);//test
   for(s=zeile;*s==' ';) s++; //Leerzeichen ueberlesen
   if(*s=='#') continue; //auskommentierte Zeilen ignorieren
   if(*s>' ') break;
  }
 while(*s!=':')
  {
   if(*s++ ==0) {fprintf(stderr,"Syntaxfehler in Eingabedatei.\n"); return;}
  }
 s++;
 if(p2==NULL) sscanf(s,cstr,p1);
 else sscanf(s,cstr,p1,p2);
}

/************** Klassen und Hauptteil des Programms *******************/
static int monatstage[13]={0,31,28,31,30,31,30,31,31,30,31,30,31};
const char *monatsname[13]={"Err","Jan","Feb","Mar","Apr","Mai","Jun","Jul","Aug","Sep","Okt","Nov","Dez"};
double lat=47.312,lon=8.492; //Geographische Koordinaten in Grad (Voreinstellung Stallikon) 
double dachschraege=45; //in Grad, Winkel gegen Ebene, Flachdach: 0, Senkrecht: 90 Grad
double dachausrichtung=10; //in Grad, Abweichung von Sueden, positiv fuer westlich
double peakleistung=1.0; //Maximalleistung der Solarzelle in kW

/************************** Zeitzonen *********************************/
// Es werden jeweils 15 Grad in einer Zeitzone verwendet. Die Zone 0 ist
// -7.5 Grad bis 7.5 Grad, dann Zone 1 von 7.5 bis 22.5 Grad. Also 15 Grad in der Mitte
// In Westlicher Richtung wird negativ gezaehlt, also -1 bis -11, oestlich 1 bis 11.

static int zeitzone=1; //0=UT, 1=MEZ, ...

void zeitzone_berechnen(double lat,double lon) //Werte in Grad
{
 if(lon>180.0) lon -= 360.0;
 else if(lon < -180.0) lon += 360.0;
 if(lon>=0) zeitzone = int((lon+7.5))/15;
 else       zeitzone = int((lon-7.5))/15;
}

void umrechnung_zonenzeit_nach_ut(int& jahr,int& monat,int& tag,int& stunde)
{
 int schaltjahr=0;
 if((jahr%4)==0 && (jahr%100!=0 || jahr%400==0)) schaltjahr=1;
 stunde -= zeitzone;
 if(stunde>=24)
  {
   int max;
   stunde -= 24;
   if(schaltjahr==1 && monat==2) max=29;
   else max=monatstage[monat];
   if(++tag>max)
    {
     tag=1;
     if(++monat==13) {monat=1; ++jahr;}
    }
  }
 else if(stunde<0)
  {
   stunde += 24;
   if(--tag==0)
    {
     if(--monat==0) {tag=31; monat=12; --jahr;}
     else
      {
       if(schaltjahr==1 && monat==2) tag=29;
       else tag=monatstage[monat];
      }
    }
  }
}

/******************* Sonnenposition berechnen *************************/
#ifdef NAEHERUNGSFORMEL
int tgberechnung(int tag,int monat)
{
 int tg=tag;
 for(int m=1;m<monat;m++) tg += monatstage[m];
 return tg;
}

/*
double deklination_in_grad(int tg) //Berechnung der Deklination in Grad
{
 return -23.45*cos(ZWEIPI*(tg+10)/365);
}
*/

double deklination(int tg) //Berechnung der Deklination in Rad (Abweichung der Sonne vom Himmelsequator)
{                          //tg=Tag im Jahr: 1=1.Jan
 return 0.4095*sin(0.016906*(tg-80.086));
}

double zeitgleichung(int tg) //Abweichung der Sonnenzeit von der Mittleren Zeit
{
 return 60.0*(-0.171*sin(0.0337*tg+0.465)-0.1299*sin(0.01787*tg-0.168));
}

double stundenwinkel(int stunde,int m,double zg) //Zeit in MEZ, Ergebnis in Grad
{
 return 15.0*(stunde+(m+zg)/60.0-(15-lon)/15.0-12.0);
}

double hoehe_berechnen(double deklinrad,double stundwinkrad) //Ergebnis in Rad
{
 double latrad=lat*GRAD;
 double x=sin(latrad)*sin(deklinrad)+cos(latrad)*cos(deklinrad)*cos(stundwinkrad);
 return asin(x);
}

double azimut_berechnen(double deklinrad,double stundwinkrad) //Ergebnis in Rad
{
 double x,y,latrad=lat*GRAD;
 y = sin(stundwinkrad);
 x = cos(stundwinkrad)*sin(latrad)-tan(deklinrad)*cos(latrad);
 return atan2(y,x);
}

void sonnenpos_berechnen(int tg,int stunde,int minute,double *hoehe,double *azimut) //Ergebnisse in Rad
{
 double stundwink,deklinrad,zg;
 zg=zeitgleichung(tg);
 deklinrad=deklination(tg);
 stundwink=stundenwinkel(stunde,minute,zg)*GRAD;
 *hoehe  = hoehe_berechnen(deklinrad,stundwink);
 *azimut = azimut_berechnen(deklinrad,stundwink);
}

#else

/************** Formel zum Sonnenposition berechnen *******************/
// JD-Formel: http://www.chem.uzh.ch/pfister/formelsammlung.html#mjd
// weitere Formeln: https://de.wikipedia.org/wiki/Sonnenstand

double MJD(int jahr,int monat,int tag,int stunde,int minute,int sekunde) //Zeit in UT
{
 int y,m,B,d=tag;
 double h=stunde+minute/60.0+sekunde/3600.0;
 if(monat<=2) {y=jahr-1; m=monat+13;}
 else         {y=jahr;   m=monat+1;}
 if(y<1582 || (y==1582 && (monat<10 || (monat==10 && tag<=4))))
            B=(y+4716)/4-1181; //bis 4.Okt.1582
 else       B=y/400-y/100+y/4; //ab 15.Okt.1582
 return 365.0*y-679004+B+int(30.6*m)+d+h/24.0;
}

void sonnenposition_berechnen(int jahr,int monat,int tag, //Datum und
			      int stunde,int minute,int sekunde, //Zeit in UT
			      double lat,double lon, //Geographische Koordinaten in Grad
			      double *hoehe,double *azimut) //Rueckgabewerte in Rad
{
 //printf("%d-%d-%d %d:%02d:%02d\n",jahr,monat,tag,stunde,minute,sekunde);//test
 //double n = JD(jahr,monat,tag,stunde,minute,sekunde) - 2451545.0;
 double n = MJD(jahr,monat,tag,stunde,minute,sekunde) - 51544.5; //in MJD ist 2400000.5 schon subrahiert
 //printf("JD: n=%f\n",n);//test
 double L = 280.460*GRAD + 0.9856474*GRAD*n; //mittlere Laenge
 double g = 357.528*GRAD + 0.9856003*GRAD*n; //mittlere Anomalie
 //eventuell noch L und g in den Bereich von 0 bis 2Pi bringen:
 while(L>=ZWEIPI) L-=ZWEIPI;
 while(g>=ZWEIPI) g-=ZWEIPI;
 //printf("L=%f Grad, g=%f Grad\n",L/GRAD,g/GRAD);//test
 double Lambda = L + 1.915*GRAD*sin(g) + 0.01997*GRAD*sin(2*g); //ekliptikale Laenge
 double epsilon = 23.439*GRAD - 0.0000004*GRAD*n; //Schiefe der Ekliptik
 double alfa = atan2(cos(epsilon)*sin(Lambda),cos(Lambda)); //Rektaszension
 double delta = asin(sin(epsilon)*sin(Lambda)); //Deklination
 //double T0 = (JD(jahr,monat,tag,0,0,0) - 2451545.0)/36525.0;
 double T0 = (MJD(jahr,monat,tag,0,0,0) - 51544.5)/36525.0;
 double T = stunde+minute/60.0+sekunde/3600.0;
 double thetahg = 6.697376 + 2400.05134*T0 + 1.002738*T;
 while(thetahg>=24.0) thetahg -= 24.0;
 double thetag = thetahg*15*GRAD; //mittlere Sternzeit
 double theta = thetag+lon*GRAD; //Stundenwinkel des Fruehlingspunkts
 double tau = theta-alfa; //Stundenwinkel der Sonne
 double phi = lat*GRAD; //Geographische Breite
 *azimut = atan2(sin(tau), cos(tau)*sin(phi) - tan(delta)*cos(phi));
 *hoehe = asin(cos(delta)*cos(tau)*cos(phi) + sin(delta)*sin(phi));
 //Refraktion beruecksichtigen:
#ifdef MITREFRAKTION
 double h= *hoehe/GRAD;
 double R=1.02/tan((h+10.3/(h+5.11))*GRAD); //Refraktion in Winkelminuten
 //if(h>= -1 && h<=1) printf("R=%f Winkelminuten\n",R);//test
 *hoehe += R*WINKELMINUTE;
#endif
}

#endif

double leistung_berechnen(double hoehe,double azimut) //Faktor abhaengig von Einstrahlunswinkel berechnen
{                                                     //hoehe und azimut in Rad
 if(hoehe<=0) return 0.0;
 double x,y,z,h;
 azimut -= dachausrichtung*GRAD;
 z=sin(hoehe);
 h=cos(hoehe);
 x=sin(azimut)*h;
 y=cos(azimut)*h;
 Vektor3d sonne(x,y,z);
 if(dachschraege!=0)
  {
   sonne.drehenyz(dachschraege*GRAD);
  }
 if(sonne.z<=0) return 0.0;
 //Da der Abstand von Sonne zu Koordinatenursprung als 1.0 gerechnet wurde, ist der Cosinus
 //vom Einstrahlwinkel gegen die Senkrechte gleich sonne.z/1.0, und das ist gerade der Leistungsfaktor.
 return sonne.z;
}

//Echter Horizont:
static double horizont[360];
void horizont_init()
{
 int i;
 for(i=0;i<360;i++)
  {
   horizont[i]=0; //provi. nur theoretischer Horizont
  }
}

//Wetterstatistik: //provi. bisher erst fuer Zuerich
static double sonnenstunden_pro_tag[13]= //fuer jeden Monat (Monate von 1 bis 12 nummeriert, 0=nicht erlaubt)
 {0,2,3,5,6,7,7,8,7,6,4,2,1}; //fuer Zuerich

/************************* Hauptprogramm ******************************/
static int jahr=2015;

int main(int argc,char *argv[])
{
 char quellname[80],zielname[80];
 FILE *fp=NULL; //,*fp2=NULL;
 int i,j=0,c;
 quellname[0]=zielname[0]=0;
 if(argc<=0)
  {/* es wurde von WorkBench (GUI, Desktop, ...) gestartet */
   workbenchflag=1;
  }
 else
  {/* es wurde von Shell (Terminal, Konsole, ...) gestartet */
   for(j=0,i=1;i<argc;i++)
	{if((c= *argv[i])=='-' || c=='?') setargflags(argv[i]);
	 else	{if(++j==1) strcpy(quellname,argv[i]);
		 else if(j==2) strcpy(zielname,argv[i]);
	}	}
  }
 if(argflag['?'] || j>MAXARG)
	{printf("ertrag  %s\n",VERSION);
	 printf("Anwendung: ertrag [-Flags] Quelle [Ziel]\n");
	 printf("  Flags: h=Hilfe\n");
	 printf("         v=Verbose, also mit Testausdrucken\n");
	 printf("         t=Test mit Voreinstellungen\n");
	 printf("         g=nach Geographischer Position fragen (sonst Voreinstellung Stallikon)\n");
	 printf("         y=Jahresverlauf berechnen\n");
	 printf("         m=Monatsverlauf berechnen\n");
	 printf("         d=Tagesverlauf berechnen\n");
	 exit(0);
	}
 if(argflag['H'])
  {
   printf("Geographische Koordinaten werden in Grad eingegeben.\n");
   printf("  Beispiel fuer Stallikon: Breite=47.312, Laenge=8.492\n");
   printf("Dachschraege wird in Grad angegeben.\n");
   printf("  Beispiele Flachdach: 0, senkrechte Zelle an Hauswand: 90\n");
   printf("Dachausrichtung ist die Abweichung von Sueden in Grad. Positiv fuer westliche,\n");
   printf("negativ fuer oestliche Abweichung.\n");
   printf("  Beispiel: Dach genau gegen Westen ausgerichtet: 90 Grad, genau gegen Osten: -90 Grad\n");
   printf("Zeit muss immer in MEZ angegeben werden. (also bei Sommerzeit 1 Stunde abziehen),\n");
   printf("oder fuer andere Orte entsprechende Zonenzeit ohne politische Anpassungen verwenden.\n");
   printf("(Zeitzone wird aus Geographischer Breite berechnet: immer 15 Grad Abschnitte)\n");
   return 0;
  }

 if(quellname[0]!=0)
  {
   setargflags("F");
   if((fp=fopen(quellname,"r"))==NULL) {printf("Fehler: konnte '%s' nicht oeffnen.\n",quellname); return 0;}
   feinlesen(fp,"%lf %lf",&lat,&lon); printf("Geographische Koordinaten: lat=%.3f lon=%.3f Grad\n",lat,lon);
   feinlesen(fp,"%lf",&dachschraege); printf("Dachschraege: %.1f Grad\n",dachschraege);
   feinlesen(fp,"%lf",&dachausrichtung); printf("Dachausrichtung: %.1f Grad\n",dachausrichtung);
   feinlesen(fp,"%lf",&peakleistung); printf("Peakleistung: %.1f Watt\n",peakleistung*1000);
   fclose(fp);
  }

 int tag=22,monat=6,stunde=12,minute=30,sek=0;
 double hoehe,azimut;
#ifdef NAEHERUNGSFORMEL
 int tg;
 double deklin,zg;
#endif

 if(!argflag['T'] && !argflag['D'] && !argflag['M'] && !argflag['J'] && !argflag['Y'])
   setargflags("Y");

 if(!argflag['T'] && !argflag['F'])
  {
   if(argflag['G'])
    {
     eingabe("Geographische Breite in Grad:",&lat);
     eingabe("Geographische Laenge in Grad:",&lon);
    }
   eingabe("Dachschraege in Grad:",&dachschraege);
   eingabe("Abweichung der Dachausrichtung von Sueden:",&dachausrichtung);
  }
 if(!argflag['T'])
  {
   eingabe2("Startdatum:",&tag,&monat);
   //if(!argflag['D']) eingabe2("Startzeit:",&stunde,&minute);
  }

 printf("Eingegebene Daten:\n");
 printf("Position: %.3f Grad Noerdliche Breite, %.3f Grad Oestliche Laenge\n",lat,lon);
 printf("Datum+Zeit: %d-%s-%d %2d:%02d:%02d\n",jahr, monatsname[monat], tag, stunde,minute,sek); 

 if(argflag['D']) //Tagesverlauf
  {
   double hoehe_vorher= -1,faktor,energiesumme=0;
   int tagflag=0;
   printf("Tagesverlauf am %d.%d.:\n",tag,monat);
   minute=0;
#ifdef NAEHERUNGSFORMEL
   tg = tgberechnung(tag,monat);
#endif
   for(stunde=0,minute=0;stunde<24;)
    {
#ifdef NAEHERUNGSFORMEL
     sonnenpos_berechnen(tg,stunde,minute,&hoehe,&azimut);
#else
     sonnenposition_berechnen(jahr,tag,monat,stunde,minute,0,lat,lon,&hoehe,&azimut);
#endif
     if(hoehe_vorher<0 && hoehe>=0)  {sonnenaufgang_anzeigen(jahr,monat,tag); tagflag=1;}
     if(hoehe_vorher>=0 && hoehe<0)  {sonnenuntergang_anzeigen(jahr,monat,tag); tagflag=0;}
     hoehe_vorher=hoehe;
     if(tagflag==1)
      {
       faktor=leistung_berechnen(hoehe,azimut);
       energiesumme += faktor*peakleistung/60; //bei 1 Min-Schritten
       if(minute==0 || minute==30)
	{
	 if(argflag['V']) printf("Sonnenpos: hoehe=%f Azimut=%f Grad\n", hoehe/GRAD, azimut/GRAD);
	 printf("%2d:%02d  Leistung: %.3f kW\n", stunde, minute, faktor*peakleistung);
	}
      }
     if(++minute==60) {minute=0; stunde++;}
    }
   printf("Gesamtenergie: %.3f kWh\n",energiesumme);
  }

 else if(argflag['M']) //Monatsverlauf
  {
   double hoehe_vorher= -1,faktor,faktor_vorher=0,energiesumme=0;
   int tagflag=0,peakflag=0,endwert=(monat+1)*31+tag;
   printf("Monatsverlauf ab %d.%d.:\n",tag,monat);
   for(stunde=0,minute=0; monat*31+tag<endwert;)
    {
#ifdef NAEHERUNGSFORMEL
     tg = tgberechnung(tag,monat);
     sonnenpos_berechnen(tg,stunde,minute,&hoehe,&azimut);
#else
     sonnenposition_berechnen(jahr,tag,monat,stunde,minute,0,lat,lon,&hoehe,&azimut);
#endif
     if(hoehe_vorher<0 && hoehe>=0)  {/*sonnenaufgang_anzeigen(tg);*/ tagflag=1;}
     if(hoehe_vorher>=0 && hoehe<0)  {/*sonnenuntergang_anzeigen(tg);*/ tagflag=0;}
     hoehe_vorher=hoehe;
     if(tagflag==1)
      {
       faktor=leistung_berechnen(hoehe,azimut);
       energiesumme += faktor*peakleistung/12; //bei 5 Min-Schritten
       if(peakflag==0 && faktor>0 && faktor_vorher>=faktor)
	{
	 peakflag=1;
	 if(argflag['V']) printf("Sonnenpos: hoehe=%f Azimut=%f Grad\n", hoehe/GRAD, azimut/GRAD);
	 printf("%2d.%s. %2d:%02d  Hoechste Leistung: %.3f kW\n",tag, monatsname[monat], stunde, minute, faktor*peakleistung);
	}
       faktor_vorher=faktor;
      }
     if((minute+=5)==60) //Zeit in 5 Min-Schritten erhoehen
      {minute=0; if(++stunde==24)
		  {stunde=0; peakflag=0; faktor_vorher=0; if(++tag>monatstage[monat]) {tag=1; if(++monat==13) monat=1;}}
      }
    }
   printf("Gesamtenergie: %.3f kWh\n",energiesumme);
  }

 else if(argflag['Y'] || argflag['J']) //Jahresverlauf
  {
   double hoehe_vorher= -1,faktor,faktor_vorher=0,energiesumme=0,monatssumme=0;
   double energiesumme_wetter=0,monatssumme_wetter=0;
   int tagflag=0,peakflag=0,jahr=2015,endwert=(13+monat)*31+tag;
   double aufgang=0,untergang=0;
   double sonnenwahrscheinlichkeit=0.25; //provi. Startwert von Ort und Datum abhaengig
   double tageslaenge=12; //provi. Startwert sollte berechnet werden

   printf("Jahresverlauf ab %d.%d.:\n",tag,monat);
   //tageslaenge=tageslaenge_berechnen(jahr,monat,tag); //Startwert berechnen
   //sonnenwahrscheinlichkeit=sonnenstunden_pro_tag[monat]/tageslaenge; //Startwert
   for(stunde=0,minute=0; (jahr*13+monat)*31+tag<endwert;)
    {
#ifdef NAEHERUNGSFORMEL
     tg = tgberechnung(tag,monat);
     sonnenpos_berechnen(tg,stunde,minute,&hoehe,&azimut);
#else
     sonnenposition_berechnen(jahr,tag,monat,stunde,minute,0,lat,lon,&hoehe,&azimut);
#endif
     if(hoehe_vorher<0 && hoehe>=0)  {aufgang=stunde+minute/60.0; tagflag=1;}
     if(hoehe_vorher>=0 && hoehe<0)  {untergang=stunde+minute/60.0; tagflag=0;}
     hoehe_vorher=hoehe;
     if(tagflag==1)
      {
       faktor=leistung_berechnen(hoehe,azimut);
       energiesumme += faktor*peakleistung/12; //bei 5 Min-Schritten
       energiesumme_wetter += faktor*peakleistung/12*sonnenwahrscheinlichkeit;
       monatssumme  += faktor*peakleistung/12; //bei 5 Min-Schritten
       monatssumme_wetter  += faktor*peakleistung/12*sonnenwahrscheinlichkeit;
       if(peakflag==0 && faktor>0 && faktor_vorher>=faktor)
	{
	 peakflag=1;
	 if(argflag['V']) printf("Sonnenpos: hoehe=%f Azimut=%f Grad\n", hoehe/GRAD, azimut/GRAD);
	 if(argflag['V']) printf("%2d.%s. %2d:%02d  Hoechste Tages-Leistung: %.3f kW\n",tag, monatsname[monat], stunde, minute, faktor*peakleistung);
	}
       faktor_vorher=faktor;
      }
     if((minute+=5)==60) //Zeit in 5 Min-Schritten erhoehen
      {minute=0;
       if(++stunde==24)
	{stunde=0; peakflag=0; faktor_vorher=0;
	 if(++tag>monatstage[monat])
	  {
	   printf("%s. Monats-Energie: %.3f kWh  mit Wetterdaten: %.3f kWh\n",
		  monatsname[monat], monatssumme, monatssumme_wetter);
	   tag=1; monatssumme=0; monatssumme_wetter=0;
	   if(++monat==13) {monat=1; jahr++;}
	  }
	 //Beruecksichtigung von Wetterstatistik:
	 tageslaenge=untergang-aufgang;
	 //printf("Tageslaenge=%f\n",tageslaenge);//test
	 if(tageslaenge<=0) tageslaenge=24;
	 sonnenwahrscheinlichkeit=sonnenstunden_pro_tag[monat]/tageslaenge;
	 aufgang=untergang=0;
	}
      }
    }
   printf("Gesamtenergie wenn immer sonnig: %.1f kWh\n",energiesumme);
   printf("Gesamtenergie mit Wetterstatist: %.1f kWh\n",energiesumme_wetter);
  }

 else if(argflag['T'])
  {
   printf("Test der Formeln:\n");
   stunde=12; minute=30; //immer zur Mittagszeit (in Zuerich)
   for(monat=1;monat<=12;monat++)
    for(tag=1;tag<=monatstage[monat];tag++)
     {
#ifdef NAEHERUNGSFORMEL
      tg = tgberechnung(tag,monat);
      zg = zeitgleichung(tg);
      deklin=deklination(tg);
      sonnenpos_berechnen(tg,stunde,minute,&hoehe,&azimut);
      printf("%2d.%d.  Tg=%d  Deklination=%f Grad  zg=%f  Sonnenpos: hoehe=%f Azimut=%f Grad\n",
	     tag,monat,tg, deklin/GRAD, zg, hoehe/GRAD, azimut/GRAD);
#else
      sonnenposition_berechnen(jahr,tag,monat,stunde,minute,0,lat,lon,&hoehe,&azimut);
      printf("%2d.%d.  Sonnenpos: hoehe=%.2f Azimut=%.2f Grad\n",
	     tag,monat, hoehe/GRAD, azimut/GRAD);
#endif
     }
  }


 return 0;
}/* ende von main */

void sonnenaufgang_anzeigen(int jahr,int tag,int monat)
{
 int h,m;
 double hoehe,azimut,hoehe0=0;
 for(h=0,m=0;h<24;)
  {
   sonnenposition_berechnen(jahr,tag,monat,h,m,0,lat,lon,&hoehe,&azimut);
   if(hoehe0<0 && hoehe>=0) break;
   hoehe0=hoehe;
   if(++m==60) {m=0; h++;}
  }
 if(h==24) h=m=0;
 printf("Sonnenaufgang: %2d:%02d\n",h,m);
}

void sonnenuntergang_anzeigen(int jahr,int tag,int monat)
{
 int h,m;
 double hoehe,azimut,hoehe0=1;
 for(h=12,m=0;h<24;)
  {
   sonnenposition_berechnen(jahr,tag,monat,h,m,0,lat,lon,&hoehe,&azimut);
   if(hoehe0>0 && hoehe<0) break;
   hoehe0=hoehe;
   if(++m==60) {m=0; h++;}
  }
 printf("Sonnenuntergang: %2d:%02d\n",h,m);
}
